#! /bin/bash

# Dublettenfinder - This bash-script finds files which
# exist at least twice

# Copyright (C) 2007  Mathias Jnger
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

if [[ "$1" = "--help" || ! "$1" ]]; then
	echo "Usage: $0 [PATH]"
	exit 1;
else
	PFAD=$1	
fi

MD5="`which md5` -r"
SORT=`which sort`
UNIQ="`which uniq` -d"
TEST="`which test` -s"

TMP_DATEI="/tmp/$$.dublettenfinder.tmp"
TMP_DATEI2="/tmp/$$.dublettenfinder.2.tmp"

find "$PFAD" -type "f" -exec $MD5 {} \; > $TMP_DATEI
awk '{print $1}' $TMP_DATEI | $SORT | $UNIQ > $TMP_DATEI2  

if $TEST $TMP_DATEI2; then
	echo "Folgende Dubletten konnten gefunden werden:"
	while read ZEILE; do
		echo
		grep "$ZEILE" "$TMP_DATEI" | awk '{print substr($0,33)}'
	done < $TMP_DATEI2
	rm $TMP_DATEI $TMP_DATEI2
	exit 0
else
	echo
	echo "Keine Dubletten gefunden."
	rm $TMP_DATEI $TMP_DATEI2
	exit 1
fi